/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package wifiloaderserver;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.net.*;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;

/**
 *
 * @author PadrinatoR
 */
public class Main {

    static ServerSocket sock;
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        ServerSocket s = (ServerSocket)null;
        Socket s1;
        OutputStream s1out;
	byte[] buffer;
	int port = 9999;

        if(args.length == 1) port = Integer.parseInt(args[0]);

        // Establece el servidor en el socket 9999 (espera 300 segundos)
        try {
            s = new ServerSocket( port,300 );
        } catch( IOException e ) {
            System.out.println( e );
	}

	JFileChooser selector = new JFileChooser();
	FileNameExtensionFilter filtro = new FileNameExtensionFilter("NDS file","nds");
	selector.setName("Select file to send");
	selector.setFileFilter(filtro);

	// Ejecuta un bucle infinito de listen/accept
        while( true ) {
            try {
		System.out.print("Waiting for client at port ");
		System.out.print(port);
		System.out.print("...\n");
                // Espera para aceptar una conexión
                s1 = s.accept();
		System.out.print("Client connected: ");
		System.out.println(s1.getInetAddress().toString());
                // Obtiene un controlador de fichero de salida asociado
                // con el socket
                s1out = s1.getOutputStream();
		
		if(selector.showOpenDialog(null)!=JFileChooser.APPROVE_OPTION){
		    s1.close();
		    continue;
		}
		
		System.out.print("Sending file...\n");

		FileInputStream fileout = new FileInputStream(selector.getSelectedFile().getAbsolutePath());

		//Envia el tamaño del archivo
		buffer = intToByteArray(fileout.available());
                s1out.write(buffer, 0, 4);

		//Envia el tamaño del nombre
		buffer = intToByteArray(selector.getSelectedFile().getName().length());
                s1out.write(buffer, 0, 4);
		
		//Envía el nombre del archivo
		s1out.write(selector.getSelectedFile().getName().getBytes(), 0, selector.getSelectedFile().getName().length());
		
		//Envia el archivo
		buffer = new byte[fileout.available()];
		fileout.read(buffer, 0, fileout.available());
		s1out.write(buffer, 0, buffer.length);

		fileout.close();
		
		System.out.print("File sent!\n\n");

		// Cierra la conexión, pero no el socket del servidor
                s1.close();
            } catch( IOException e ) {
                System.out.println( e );
            }
        }
    }

    private static byte[] intToByteArray (final int integer) throws IOException {	
	ByteArrayOutputStream bos = new ByteArrayOutputStream();
	DataOutputStream dos = new DataOutputStream(bos);
	dos.writeInt(integer);
	dos.flush();
	return bos.toByteArray();
    }
}
