#include <PA9.h>
#include <fat.h>
#include <stdlib.h>
#include "bootlib.h"

#define BUFFER_SIZE 8192

int main() {
	int file_size, filename_length, rec_bytes;
	char buffer[BUFFER_SIZE+1], filename[1024];
	char serv[] = "192.168.1.2\0\0\0\0";
	int port = atoi("9999\0");

	PA_Init();
	PA_InitVBL();
	PA_InitText(0, 0);

	PA_OutputText(0, 0, 0, "Wifiloader by PadrinatoR 2008");
	PA_OutputText(0, 0, 2, "Connecting using WFC data...");
	
	PA_InitWifi();
	PA_ConnectWifiWFC();

	PA_OutputText(0, 0, 2, "Waiting for server... port %d", port);
	
	int sock;
	if(!PA_InitSocket(&sock,serv,port,PA_NORMAL_TCP)){
		PA_OutputText(0, 0, 2, "Cannot connect to the server    ");
		return 0;
	}

	PA_OutputText(0, 0, 2, "Server ready                    ");

	rec_bytes = 0;
	//Recibo el tamao del archivo
	while(rec_bytes < sizeof(file_size)){
		rec_bytes += recv(sock, (char *) (&file_size + rec_bytes), sizeof(file_size) - rec_bytes, 0);
	}
	file_size = ntohl(file_size);
	
	rec_bytes = 0;
	//Recibo el tamao del nombre de archivo
	while(rec_bytes < sizeof(filename_length)){
		rec_bytes += recv(sock, (char *) (&filename_length + rec_bytes), sizeof(filename_length) - rec_bytes, 0);
	}
	filename_length = ntohl(filename_length);
	
	rec_bytes = 0;
	//Recibo el nombre de archivo
	while(rec_bytes < filename_length){
		rec_bytes += recv(sock, (char *) (&filename + rec_bytes), filename_length - rec_bytes, 0);
	}
	
	filename[filename_length] = '\0';
	
	PA_OutputText(0, 0, 3, "File: %s", filename);
	PA_OutputText(0, 0, 4, "Size: %d", file_size);
	
	if(!fatInitDefault()){
		PA_OutputText(0, 0, 5, "FAT couldn't be initialised!");
		return 0;
	}
	
	//ABRIR FICHERO
	FILE *out = fopen(filename, "rb");
	if(out != NULL){
		fclose(out);
		out = NULL;

		PA_OutputText(0, 0, 5, "Overwrite file? A: Yes - B: No");
		while (1) {		
			if(Pad.Newpress.A) break;
			if(Pad.Newpress.B) return 0;
				
			PA_WaitForVBL();
		}
	}
	
	out = fopen(filename, "wb");
	
	if(out == NULL){
		PA_OutputText(0, 0, 6, "File couldn't be opened!");
		return 0;
	}
	
	int total_rec_bytes = 0;
	//Recibo el fichero
	while(total_rec_bytes < file_size){
		PA_OutputText(0, 0, 6, "Received %d KB", total_rec_bytes / 1024);

		rec_bytes = recv(sock, buffer, BUFFER_SIZE, 0);
		total_rec_bytes += rec_bytes;
		
		//ESCRIBIR EN EL FICHERO
		fwrite(buffer, rec_bytes, 1, out);
	}
	
	//CERRAR FICHERO
	fclose(out);

	PA_OutputText(0, 0, 6, "Transfer completed!         ");
	PA_OutputText(0, 0, 8, "Press A to boot it");
	
	while (1) {
		
		if(Pad.Newpress.A) {
			Wifi_DisconnectAP();
			Wifi_DisableWifi();
			
			bootnds(filename);
		}
		
		PA_WaitForVBL();
	}
	
	Wifi_DisconnectAP();
	Wifi_DisableWifi();
	
	return 0;
} 
